-- B97306A.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- OBJECTIVE:
--     CHECK THAT IF AN ENTRY CALL IS RENAMED AS A PROCEDURE, THEN THE
--     PROCEDURE NAME CANNOT BE USED IN PLACE OF THE ENTRY NAME IN A
--     TIMED ENTRY CALL.

-- HISTORY:
--     DHH 03/22/88 CREATED ORIGINAL TEST.
--     WMC 04/07/92 REMOVED UNNECESSARY REFERENCES TO PACKAGE REPORT AND 
--                  PROCEDURE RESULT.

PROCEDURE B97306A IS

     TASK TE IS
          ENTRY INTGR(X : INTEGER);
     END TE;

     PROCEDURE INTEGR(X : INTEGER) RENAMES TE.INTGR;

     PROCEDURE DUMMY IS
     BEGIN
          NULL;
     END DUMMY;

     TASK BODY TE IS
          Y : INTEGER;
     BEGIN
          ACCEPT INTGR(X : INTEGER) DO
               Y := X;
          END INTGR;
     END TE;
BEGIN
     INTEGR(5);

     SELECT
          INTEGR(5);                                 -- ERROR:
     OR
          DELAY 5.0;
          DUMMY;
     END SELECT;

END B97306A;
