-- BD8002A.TST

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- OBJECTIVE:
--     IF MACHINE CODE INSERTIONS ARE SUPPORTED, CHECK THAT NEITHER
--     A USER-DEFINED RECORD TYPE NOR A TYPE DERIVED FROM A RECORD
--     TYPE IN 'MACHINE_CODE' CAN BE USED IN A CODE STATEMENT.

-- APPLICABILITY CRITERIA:
--     THIS TEST IS APPLICABLE ONLY TO IMPLEMENTATIONS THAT SUPPORT
--     MACHINE CODE INSERTIONS.

--     IF SUCH INSERTIONS ARE NOT SUPPORTED, THE "WITH MACHINE_CODE;"
--     CLAUSE MUST BE REJECTED.


-- MACRO SUBSTITUTION:
--     IF MACHINE CODE INSERTIONS ARE SUPPORTED THEN A RECORD TYPE NAME
--     DEFINED IN THE PACKAGE 'MACHINE_CODE' MUST BE SUBSTITUTED FOR
--     THE MACRO $RECORD_NAME AND A DISCRIMINANT PART, AS APPROPRIATE,
--     MUST BE SUBSTITUTED FOR THE MACRO $OPTIONAL_DISC. A RECORD TYPE
--     DEFINITION OF THAT RECORD MUST BE SUBSTITUTED FOR THE MACRO
--     $RECORD_DEFINITION.  THE MACRO $MACHINE_CODE_STATEMENT MUST BE
--     REPLACED BY A VALID CODE STATEMENT WHICH CONTAINS THE NAME
--     DEFINED IN THE MACRO SUBSTITUTION FOR $RECORD_NAME.

--     IF MACHINE CODE INSERTIONS ARE NOT SUPPORTED, THEN SUBSTITUTE
--     THE ADA NULL STATEMENT (IE: NULL;) FOR $MACHINE_CODE_STATEMENT,
--     NO_SUCH_MACHINE_CODE_TYPE FOR $RECORD_NAME, 
--     NO_SUCH_MACHINE_CODE_DISC FOR $OPTIONAL_DISC, AND A TYPE 
--     DEFINITION OF A NULL RECORD FOR $RECORD_DEFINITION.

-- HISTORY:
--     DHH 08/26/88 CREATED ORIGINAL TEST.
--     RJW 03/28/90 ADDED MACRO $RECORD_NAME_FOLLOWED_BY_OPTIONAL_DISC.
--     THS 09/20/90 REWORDED HEADER AND REPLACED MACRO
--                  $RECORD_NAME_FOLLOWED_BY_OPTIONAL_DISC WITH
--                  A CATENATION OF $RECORD_NAME & $OPTIONAL_DISC.

WITH SYSTEM; USE SYSTEM;
WITH MACHINE_CODE;                                     -- N/A => ERROR.
USE MACHINE_CODE;
PROCEDURE BD8002A IS

     PROCEDURE M_CODE1 IS
          TYPE $RECORD_NAME IS NEW 
               MACHINE_CODE.$RECORD_NAME;

          PROCEDURE MACH_CODE IS
          BEGIN
              $MACHINE_CODE_STATEMENT                        -- ERROR:
          END MACH_CODE;
     BEGIN
          NULL;
     END M_CODE1;

     PROCEDURE M_CODE2 IS
          TYPE $RECORD_NAME$OPTIONAL_DISC IS
               $RECORD_DEFINITION

          PROCEDURE MACH_CODE IS
          BEGIN
              $MACHINE_CODE_STATEMENT                        -- ERROR:
          END MACH_CODE;
     BEGIN
          NULL;
     END M_CODE2;

BEGIN
     NULL;
END BD8002A;
